"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setSecurity = exports.setResponseStatus = exports.setResponseRepresentations = exports.setResponseHeaders = exports.setResponseBody = exports.setResponse = exports.setRequestQuery = exports.setRequestPath = exports.setRequestHeaders = exports.setRequestBody = exports.setRequest = exports.setOptions = exports.put = exports.post = exports.patch = exports.make = exports.isFullResponse = exports.isApiEndpoint = exports.getSecurity = exports.getResponse = exports.getRequest = exports.getPath = exports.getOptions = exports.getMethod = exports.getId = exports.get = exports.delete = exports.addResponse = exports.TypeId = void 0;
var internal = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./internal/api-endpoint.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/**
 * @since 1.0.0
 * @category type id
 */
const TypeId = exports.TypeId = internal.TypeId;
/**
 * @category constructors
 * @since 1.0.0
 */
const make = exports.make = internal.make;
/**
 * @category constructors
 * @since 1.0.0
 */
const get = (...args) => make("GET", ...args);
/**
 * @category constructors
 * @since 1.0.0
 */
exports.get = get;
const post = (...args) => make("POST", ...args);
/**
 * @category constructors
 * @since 1.0.0
 */
exports.post = post;
const put = (...args) => make("PUT", ...args);
/**
 * @category constructors
 * @since 1.0.0
 */
exports.put = put;
const patch = (...args) => make("PATCH", ...args);
exports.patch = patch;
const _delete = (...args) => make("DELETE", ...args);
exports.delete = _delete;
/**
 * @category modifications
 * @since 1.0.0
 */
const setRequest = exports.setRequest = internal.setRequest;
/**
 * @category modifications
 * @since 1.0.0
 */
const setRequestBody = exports.setRequestBody = internal.setRequestBody;
/**
 * @category modifications
 * @since 1.0.0
 */
const setRequestPath = exports.setRequestPath = internal.setRequestPath;
/**
 * @category modifications
 * @since 1.0.0
 */
const setRequestQuery = exports.setRequestQuery = internal.setRequestQuery;
/**
 * @category modifications
 * @since 1.0.0
 */
const setRequestHeaders = exports.setRequestHeaders = internal.setRequestHeaders;
/**
 * @category modifications
 * @since 1.0.0
 */
const setSecurity = exports.setSecurity = internal.setSecurity;
/**
 * @category modifications
 * @since 1.0.0
 */
const setOptions = exports.setOptions = internal.setOptions;
/**
 * @category modifications
 * @since 1.0.0
 */
const getId = exports.getId = internal.getId;
/**
 * @category getters
 * @since 1.0.0
 */
const getRequest = exports.getRequest = internal.getRequest;
/**
 * @category getters
 * @since 1.0.0
 */
const getResponse = exports.getResponse = internal.getResponse;
/**
 * @category getters
 * @since 1.0.0
 */
const getSecurity = exports.getSecurity = internal.getSecurity;
/**
 * @category getters
 * @since 1.0.0
 */
const getPath = exports.getPath = internal.getPath;
/**
 * @category getters
 * @since 1.0.0
 */
const getMethod = exports.getMethod = internal.getMethod;
/**
 * @category getters
 * @since 1.0.0
 */
const getOptions = exports.getOptions = internal.getOptions;
/**
 * @category getters
 * @since 1.0.0
 */
const setResponse = exports.setResponse = internal.setResponse;
/**
 * @category modifications
 * @since 1.0.0
 */
const setResponseStatus = exports.setResponseStatus = internal.setResponseStatus;
/**
 * @category modifications
 * @since 1.0.0
 */
const setResponseBody = exports.setResponseBody = internal.setResponseBody;
/**
 * @category modifications
 * @since 1.0.0
 */
const setResponseHeaders = exports.setResponseHeaders = internal.setResponseHeaders;
/**
 * @category modifications
 * @since 1.0.0
 */
const addResponse = exports.addResponse = internal.addResponse;
/**
 * @category modifications
 * @since 1.0.0
 */
const setResponseRepresentations = exports.setResponseRepresentations = internal.setResponseRepresentations;
/**
 * Is used by the client and server implementation to determine whether
 * to use a full `{ status; body; headers }` response or just the body.
 *
 * The logic is that if there is only one declared response and it doesn't
 * specify any headers, the simplified version with body only is used, otherwise
 * the full response is used.
 *
 * @category getters
 * @since 1.0.0
 */
const isFullResponse = exports.isFullResponse = internal.isFullResponse;
/**
 * @category refinements
 * @since 1.0.0
 */
const isApiEndpoint = exports.isApiEndpoint = internal.isApiEndpoint;
//# sourceMappingURL=ApiEndpoint.js.map