"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeServerSide = exports.makeClientSideResponseValidation = exports.makeClientSideRequestValidation = exports.makeClientSide = exports.isServerSideError = exports.isClientSideError = exports.ServerSideErrorTypeId = exports.ClientSideErrorTypeId = void 0;
var internal = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./internal/client-error.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/**
 * @since 1.0.0
 * @category type id
 */
const ClientSideErrorTypeId = exports.ClientSideErrorTypeId = internal.ClientSideErrorTypeId;
/**
 * @since 1.0.0
 * @category type id
 */
const ServerSideErrorTypeId = exports.ServerSideErrorTypeId = internal.ServerSideErrorTypeId;
/**
 * @category constructors
 * @since 1.0.0
 */
const makeClientSide = exports.makeClientSide = internal.makeClientSide;
/**
 * @category constructors
 * @since 1.0.0
 */
const makeServerSide = exports.makeServerSide = internal.makeServerSide;
/**
 * @category constructors
 * @since 1.0.0
 */
const makeClientSideRequestValidation = exports.makeClientSideRequestValidation = internal.makeClientSideRequestValidation;
/**
 * @category constructors
 * @since 1.0.0
 */
const makeClientSideResponseValidation = exports.makeClientSideResponseValidation = internal.makeClientSideResponseValidation;
/**
 * @category refinements
 * @since 1.0.0
 */
const isClientSideError = exports.isClientSideError = internal.isClientSideError;
/**
 * @category refinements
 * @since 1.0.0
 */
const isServerSideError = exports.isServerSideError = internal.isServerSideError;
//# sourceMappingURL=ClientError.js.map