"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.merge = exports.mapRouter = exports.make = exports.isRouterBuilder = exports.handler = exports.handleRaw = exports.handle = exports.getRouter = exports.buildPartial = exports.build = exports.TypeId = void 0;
var internal = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./internal/router-builder.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/**
 * @since 1.0.0
 * @category type id
 */
const TypeId = exports.TypeId = internal.TypeId;
/**
 * Create a new unimplemeted `RouterBuilder` from an `Api`.
 *
 * @category handling
 * @since 1.0.0
 */
const make = exports.make = internal.make;
/**
 * Handle an endpoint using a raw `Router.Route.Handler`.
 *
 * @category handling
 * @since 1.0.0
 */
const handleRaw = exports.handleRaw = internal.handleRaw;
/**
 * Handle an endpoint using a handler function.
 *
 * @category constructors
 * @since 1.0.0
 */
const handle = exports.handle = internal.handle;
/**
 * Handle an endpoint using a handler function.
 *
 * @category constructors
 * @since 1.0.0
 */
const handler = exports.handler = internal.handler;
/**
 * Modify the `Router`.
 *
 * @category mapping
 * @since 1.0.0
 */
const mapRouter = exports.mapRouter = internal.mapRouter;
/**
 * Handle an endpoint using a raw `Router.Route.Handler`.
 *
 * @category destructors
 * @since 1.0.0
 */
const getRouter = exports.getRouter = internal.getRouter;
/**
 * Create an `App` instance.
 *
 * @category destructors
 * @since 1.0.0
 */
const build = exports.build = internal.build;
/**
 * Create an `App` instance.
 *
 * Warning: this function doesn't enforce all the endpoints are implemented and
 * a running server might not conform the given Api spec.
 *
 * @category destructors
 * @since 1.0.0
 */
const buildPartial = exports.buildPartial = internal.buildPartial;
/**
 * @category combining
 * @since 1.0.0
 */
const merge = exports.merge = internal.merge;
/**
 * @category refinements
 * @since 1.0.0
 */
const isRouterBuilder = exports.isRouterBuilder = internal.isRouterBuilder;
//# sourceMappingURL=RouterBuilder.js.map