"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unit = exports.or = exports.never = exports.mapSchema = exports.mapHandler = exports.mapEffect = exports.map = exports.make = exports.handleRequest = exports.getOpenApi = exports.bearer = exports.basic = exports.asSome = exports.as = exports.apiKey = exports.and = exports.TypeId = void 0;
var internal = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./internal/security.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/**
 * @since 1.0.0
 * @category type id
 */
const TypeId = exports.TypeId = internal.TypeId;
/**
 * @category constructors
 * @since 1.0.0
 */
const make = exports.make = internal.make;
/**
 * @category getters
 * @since 1.0.0
 */
const handleRequest = exports.handleRequest = internal.handleRequest;
/**
 * @category getters
 * @since 1.0.0
 */
const getOpenApi = exports.getOpenApi = internal.getOpenApi;
/**
 * @category combinators
 * @since 1.0.0
 */
const mapHandler = exports.mapHandler = internal.mapHandler;
/**
 * @category combinators
 * @since 1.0.0
 */
const and = exports.and = internal.and;
/**
 * @category combinators
 * @since 1.0.0
 */
const or = exports.or = internal.or;
/**
 * @category combinators
 * @since 1.0.0
 */
const map = exports.map = internal.map;
/**
 * @category combinators
 * @since 1.0.0
 */
const as = exports.as = internal.as;
/**
 * @category combinators
 * @since 1.0.0
 */
const asSome = exports.asSome = internal.asSome;
/**
 * @category combinators
 * @since 1.0.0
 */
const mapEffect = exports.mapEffect = internal.mapEffect;
/**
 * @category combinators
 * @since 1.0.0
 */
const mapSchema = exports.mapSchema = internal.mapSchema;
/**
 * Creates bearer http security
 *
 * @category constructors
 * @since 1.0.0
 */
const bearer = exports.bearer = internal.bearer;
/**
 * Creates basic http security
 *
 * @category constructors
 * @since 1.0.0
 */
const basic = exports.basic = internal.basic;
/**
 * Creates always allowing security without a security scheme
 *
 * @category constructors
 * @since 1.0.0
 */
const unit = exports.unit = internal.unit;
/**
 * Creates always failing security without a security scheme
 *
 * @category constructors
 * @since 1.0.0
 */
const never = exports.never = internal.never;
/**
 * Creates basic http security
 *
 * @category constructors
 * @since 1.0.0
 */
const apiKey = exports.apiKey = internal.apiKey;
//# sourceMappingURL=Security.js.map