"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.variance = exports.validateNewEndpoint = exports.setOptions = exports.make = exports.isApiGroup = exports.addEndpoint = exports.TypeId = exports.ApiGroupImpl = void 0;
var Pipeable = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Pipeable"));
var ApiEndpoint = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiEndpoint.js"));
var api_endpoint = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./api-endpoint.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const TypeId = exports.TypeId = /*#__PURE__*/Symbol.for("effect-http/Api/ApiGroupTypeId");
/** @internal */
const variance = exports.variance = {
  /* c8 ignore next */
  _A: _ => _
};
/** @internal */
class ApiGroupImpl {
  name;
  endpoints;
  options;
  [TypeId] = variance;
  constructor(name, endpoints, options) {
    this.name = name;
    this.endpoints = endpoints;
    this.options = options;
  }
  pipe() {
    return Pipeable.pipeArguments(this, arguments);
  }
}
/** @internal */
exports.ApiGroupImpl = ApiGroupImpl;
const isApiGroup = u => typeof u === "object" && u !== null && TypeId in u;
/** @internal */
exports.isApiGroup = isApiGroup;
const make = (name, options) => new ApiGroupImpl(name, [], {
  ...options
});
/** @internal */
exports.make = make;
const validateNewEndpoint = (self, endpoint) => {
  if (self.endpoints.some(e => ApiEndpoint.getId(e) === ApiEndpoint.getId(endpoint))) {
    throw new Error(`Endpoint with id ${ApiEndpoint.getId(endpoint)} already exists`);
  }
};
/** @internal */
exports.validateNewEndpoint = validateNewEndpoint;
const addEndpoint = endpoint => self => {
  api_endpoint.validateEndpoint(endpoint);
  validateNewEndpoint(self, endpoint);
  return new ApiGroupImpl(self.name, [...self.endpoints, endpoint], self.options);
};
/** @internal */
exports.addEndpoint = addEndpoint;
const setOptions = options => self => new ApiGroupImpl(self.name, self.endpoints, {
  ...self.options,
  ...options
});
exports.setOptions = setOptions;
//# sourceMappingURL=api-group.js.map