"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.variance = exports.setQuery = exports.setPath = exports.setHeaders = exports.setBody = exports.getQuerySchema = exports.getPathSchema = exports.getHeadersSchema = exports.getBodySchema = exports.defaultRequest = exports.TypeId = exports.ApiRequestImpl = void 0;
var Pipeable = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Pipeable"));
var ApiSchema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiSchema.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const TypeId = exports.TypeId = /*#__PURE__*/Symbol.for("effect-http/Api/RequestTypeId");
/** @internal */
const variance = exports.variance = {
  /* c8 ignore next */
  _B: _ => _,
  /* c8 ignore next */
  _P: _ => _,
  /* c8 ignore next */
  _Q: _ => _,
  /* c8 ignore next */
  _H: _ => _,
  /* c8 ignore next */
  _R: _ => _
};
/** @internal */
class ApiRequestImpl {
  body;
  path;
  query;
  headers;
  [TypeId] = variance;
  constructor(body, path, query, headers) {
    this.body = body;
    this.path = path;
    this.query = query;
    this.headers = headers;
  }
  pipe() {
    return Pipeable.pipeArguments(this, arguments);
  }
}
/** @internal */
exports.ApiRequestImpl = ApiRequestImpl;
const defaultRequest = exports.defaultRequest = /*#__PURE__*/new ApiRequestImpl(ApiSchema.Ignored, ApiSchema.Ignored, ApiSchema.Ignored, ApiSchema.Ignored);
/** @internal */
const getBodySchema = request => request.body;
/** @internal */
exports.getBodySchema = getBodySchema;
const getPathSchema = request => request.path;
/** @internal */
exports.getPathSchema = getPathSchema;
const getQuerySchema = request => request.query;
/** @internal */
exports.getQuerySchema = getQuerySchema;
const getHeadersSchema = request => request.headers;
/** @internal */
exports.getHeadersSchema = getHeadersSchema;
const setBody = schema => request => new ApiRequestImpl(schema, getPathSchema(request), getQuerySchema(request), getHeadersSchema(request));
/** @internal */
exports.setBody = setBody;
const setPath = schema => request => new ApiRequestImpl(getBodySchema(request), schema, getQuerySchema(request), getHeadersSchema(request));
/** @internal */
exports.setPath = setPath;
const setQuery = schema => request => new ApiRequestImpl(getBodySchema(request), getPathSchema(request), schema, getHeadersSchema(request));
/** @internal */
exports.setQuery = setQuery;
const setHeaders = schema => request => new ApiRequestImpl(getBodySchema(request), getPathSchema(request), getQuerySchema(request), schema // TODO: transform schema properties to lowercase
);
exports.setHeaders = setHeaders;
//# sourceMappingURL=api-request.js.map