"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.variance = exports.setStatus = exports.setRepresentations = exports.setHeaders = exports.setBody = exports.make = exports.isApiResponse = exports.getStatus = exports.getRepresentations = exports.getHeadersSchema = exports.getBodySchema = exports.defaultResponse = exports.TypeId = void 0;
var Pipeable = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Pipeable"));
var Predicate = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Predicate"));
var ApiSchema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiSchema.js"));
var Representation = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../Representation.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const TypeId = exports.TypeId = /*#__PURE__*/Symbol.for("effect-http/Api/ResponseTypeId");
/** @internal */
const variance = exports.variance = {
  /* c8 ignore next */
  _S: _ => _,
  /* c8 ignore next */
  _B: _ => _,
  /* c8 ignore next */
  _H: _ => _,
  /* c8 ignore next */
  _R: _ => _
};
/** @internal */
class ApiResponseImpl {
  status;
  body;
  headers;
  representations;
  [TypeId] = variance;
  constructor(status, body, headers, representations) {
    this.status = status;
    this.body = body;
    this.headers = headers;
    this.representations = representations;
  }
  pipe() {
    return Pipeable.pipeArguments(this, arguments);
  }
}
/** @internal */
const defaultRepresentations = [Representation.json];
/** @internal */
const defaultResponse = exports.defaultResponse = /*#__PURE__*/new ApiResponseImpl(200, ApiSchema.Ignored, ApiSchema.Ignored, defaultRepresentations);
/** @internal */
const isApiResponse = u => Predicate.hasProperty(u, TypeId) && Predicate.isObject(u[TypeId]);
/** @internal */
exports.isApiResponse = isApiResponse;
const make = (status, body, headers, representations) => new ApiResponseImpl(status, body ?? ApiSchema.Ignored, headers ?? ApiSchema.Ignored, representations ?? defaultRepresentations);
/** @internal */
exports.make = make;
const setStatus = status => response => make(status, getBodySchema(response), getHeadersSchema(response), getRepresentations(response));
/** @internal */
exports.setStatus = setStatus;
const setBody = schema => response => make(getStatus(response), schema, getHeadersSchema(response), getRepresentations(response));
/** @internal */
exports.setBody = setBody;
const setHeaders = schema => response => make(getStatus(response), getBodySchema(response), schema, getRepresentations(response));
/** @internal */
exports.setHeaders = setHeaders;
const setRepresentations = representations => response => make(getStatus(response), getBodySchema(response), getHeadersSchema(response), representations);
/** @internal */
exports.setRepresentations = setRepresentations;
const getStatus = response => response.status;
/** @internal */
exports.getStatus = getStatus;
const getHeadersSchema = response => response.headers;
/** @internal */
exports.getHeadersSchema = getHeadersSchema;
const getBodySchema = response => response.body;
/** @internal */
exports.getBodySchema = getBodySchema;
const getRepresentations = response => response.representations;
exports.getRepresentations = getRepresentations;
//# sourceMappingURL=api-response.js.map