"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.variance = exports.setOptions = exports.make = exports.isApi = exports.getEndpoint = exports.addGroup = exports.addEndpoint = exports.TypeId = void 0;
var Array = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Array"));
var Pipeable = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Pipeable"));
var ApiEndpoint = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiEndpoint.js"));
var ApiGroup = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiGroup.js"));
var api_endpoint = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./api-endpoint.js"));
var api_group = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./api-group.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const TypeId = exports.TypeId = /*#__PURE__*/Symbol.for("effect-http/Api/TypeId");
/** @internal */
const variance = exports.variance = {
  /* c8 ignore next */
  _A: _ => _
};
/** @internal */
class ApiImpl {
  groups;
  options;
  [TypeId] = variance;
  constructor(groups, options) {
    this.groups = groups;
    this.options = options;
  }
  pipe() {
    return Pipeable.pipeArguments(this, arguments);
  }
}
/** @internal */
const DEFAULT_API_OPTIONS = {
  title: "Api",
  version: "1.0.0"
};
/** @internal */
const isApi = u => typeof u === "object" && u !== null && TypeId in u;
/** @internal */
exports.isApi = isApi;
const make = options => new ApiImpl([], {
  ...DEFAULT_API_OPTIONS,
  ...options
});
/** @internal */
exports.make = make;
const addEndpoint = endpoint => api => {
  api_endpoint.validateEndpoint(endpoint);
  api.groups.forEach(group => api_group.validateNewEndpoint(group, endpoint));
  const defaultGroup = api.groups.find(group => group.name === "default") ?? ApiGroup.make("default");
  const groupsWithoutDefault = api.groups.filter(group => group.name !== "default");
  const newDefaultGroup = new api_group.ApiGroupImpl("default", [...defaultGroup.endpoints, endpoint], defaultGroup.options);
  return new ApiImpl([...groupsWithoutDefault, newDefaultGroup], api.options);
};
/** @internal */
exports.addEndpoint = addEndpoint;
const addGroup = group => self => {
  const current = self.groups.flatMap(group => group.endpoints.map(ApiEndpoint.getId));
  const incomming = group.endpoints.map(ApiEndpoint.getId);
  if (Array.intersection(current, incomming).length > 0) {
    throw new Error(`Duplicate endpoint ids found in the group`);
  }
  return new ApiImpl([...self.groups, group], self.options);
};
/** @internal */
exports.addGroup = addGroup;
const getEndpoint = (api, id) => {
  const endpoint = api.groups.flatMap(group => group.endpoints).find(endpoint => ApiEndpoint.getId(endpoint) === id);
  if (endpoint === undefined) {
    throw new Error(`Endpoint with id ${id} not found`);
  }
  return endpoint;
};
/** @internal */
exports.getEndpoint = getEndpoint;
const setOptions = options => self => new ApiImpl(self.groups, {
  ...self.options,
  ...options
});
exports.setOptions = setOptions;
//# sourceMappingURL=api.js.map