"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeServerSide = exports.makeClientSideResponseValidation = exports.makeClientSideRequestValidation = exports.makeClientSide = exports.isServerSideError = exports.isClientSideError = exports.ServerSideErrorTypeId = exports.ClientSideErrorTypeId = exports.ClientErrorServerSideImpl = exports.ClientErrorClientSideImpl = void 0;
var Data = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Data"));
var Predicate = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Predicate"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const ClientSideErrorTypeId = exports.ClientSideErrorTypeId = /*#__PURE__*/Symbol.for("effect-http/ClientError/ClientSideErrorTypeId");
/** @internal */
const ServerSideErrorTypeId = exports.ServerSideErrorTypeId = /*#__PURE__*/Symbol.for("effect-http/ClientError/ServerSideErrorTypeId");
/** @internal */
class ClientErrorServerSideImpl extends /*#__PURE__*/Data.TaggedError("ClientError") {
  [ServerSideErrorTypeId] = {};
}
/** @internal */
exports.ClientErrorServerSideImpl = ClientErrorServerSideImpl;
class ClientErrorClientSideImpl extends /*#__PURE__*/Data.TaggedError("ClientError") {
  [ClientSideErrorTypeId] = {};
}
/** @internal */
exports.ClientErrorClientSideImpl = ClientErrorClientSideImpl;
const makeClientSide = (error, message) => {
  return new ClientErrorClientSideImpl({
    message: message ?? (typeof error === "string" ? error : JSON.stringify(error)),
    error,
    side: "client"
  });
};
/** @internal */
exports.makeClientSide = makeClientSide;
const getMessage = error => {
  if (typeof error === "string") {
    return error;
  }
  if (error instanceof Error) {
    return error.message;
  }
  if (typeof error === "object" && error !== null && "message" in error && typeof error.message === "string") {
    return error.message;
  }
  return JSON.stringify(error);
};
/** @internal */
const makeServerSide = (error, status, message) => {
  return new ClientErrorServerSideImpl({
    message: message ?? getMessage(error),
    error,
    status,
    side: "server"
  });
};
/** @internal */
exports.makeServerSide = makeServerSide;
const makeClientSideRequestValidation = location => error => new ClientErrorClientSideImpl({
  message: `Failed to encode ${location}. ${error.message}`,
  error,
  side: "client"
});
/** @internal */
exports.makeClientSideRequestValidation = makeClientSideRequestValidation;
const makeClientSideResponseValidation = location => error => new ClientErrorClientSideImpl({
  message: `Failed to validate response ${location}. ${error.message}`,
  error,
  side: "client"
});
/** @internal */
exports.makeClientSideResponseValidation = makeClientSideResponseValidation;
const isClientSideError = u => Predicate.isTagged(u, "ClientError") && ClientSideErrorTypeId in u;
/** @internal */
exports.isClientSideError = isClientSideError;
const isServerSideError = u => Predicate.isTagged(u, "ClientError") && ServerSideErrorTypeId in u;
exports.isServerSideError = isServerSideError;
//# sourceMappingURL=client-error.js.map