"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeSchema = exports.make = exports.handleRemaining = exports.handle = void 0;
var Array = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Array"));
var Effect = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Effect"));
var _Function = /*#__PURE__*/require("effect/Function");
var Unify = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Unify"));
var Api = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../Api.js"));
var ApiEndpoint = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiEndpoint.js"));
var HttpError = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../HttpError.js"));
var RouterBuilder = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../RouterBuilder.js"));
var example_compiler = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./example-compiler.js"));
var utils = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./utils.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const make = api => handleRemaining(RouterBuilder.make(api));
/** @internal */
exports.make = make;
const handle = id => routerBuilder => {
  const endpoint = Api.getEndpoint(routerBuilder.api, id);
  return (0, _Function.pipe)(routerBuilder, RouterBuilder.handle(id, createExampleHandler(endpoint)));
};
/** @internal */
exports.handle = handle;
const handleRemaining = routerBuilder => (0, _Function.pipe)(routerBuilder.remainingEndpoints, Array.reduce(routerBuilder, (server, endpoint) => (0, _Function.pipe)(server, RouterBuilder.handle(ApiEndpoint.getId(endpoint), createExampleHandler(endpoint)))));
/** @internal */
exports.handleRemaining = handleRemaining;
const createExampleHandler = endpoint => {
  const responseSchema = utils.createResponseSchema(endpoint);
  return () => (0, _Function.pipe)(Unify.unify(responseSchema && example_compiler.randomExample(responseSchema) || Effect.void), Effect.mapError(error => HttpError.internalServerError(`Sorry, I don't have any example response. ${JSON.stringify(error)}`)));
};
const makeSchema = schema => Effect.orDie(example_compiler.randomExample(schema));
exports.makeSchema = makeSchema;
//# sourceMappingURL=example-server.js.map