"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.variance = exports.toResponse = exports.makeStatus = exports.make = exports.isHttpError = exports.TypeId = exports.HttpErrorImpl = void 0;
var Cookies = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/Cookies"));
var Headers = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/Headers"));
var HttpBody = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/HttpBody"));
var HttpServerResponse = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/HttpServerResponse"));
var Data = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Data"));
var _Function = /*#__PURE__*/require("effect/Function");
var Pipeable = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Pipeable"));
var Stream = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Stream"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const TypeId = exports.TypeId = /*#__PURE__*/Symbol.for("effect-http/HttpError/TypeId");
/** @internal */
const variance = exports.variance = {};
/** @internal */
const unsafeIsStream = u => typeof u === "object" && u !== null && Stream.StreamTypeId in u;
/** @internal */
class HttpErrorImpl extends /*#__PURE__*/Data.TaggedError("HttpError") {
  [TypeId] = variance;
  static unsafeFromUnknown(status, body, options) {
    let content = undefined;
    if (body === undefined) {
      content = HttpBody.empty;
    } else if (body instanceof Uint8Array) {
      content = HttpBody.uint8Array(body);
    } else if (typeof body === "string") {
      content = HttpBody.text(body);
    } else if (unsafeIsStream(body)) {
      content = HttpBody.stream(body);
    } else {
      content = HttpBody.unsafeJson(body);
    }
    return new HttpErrorImpl({
      status,
      content,
      headers: options?.headers ?? Headers.empty,
      cookies: options?.cookies ?? Cookies.empty
    });
  }
  pipe() {
    return Pipeable.pipeArguments(this, arguments);
  }
}
/** @internal */
exports.HttpErrorImpl = HttpErrorImpl;
const toResponse = error => {
  const options = {
    status: error.status,
    contentType: error.content.contentType,
    headers: (0, _Function.pipe)(error.headers, error.content.contentLength ? Headers.set("Content-Length", error.content.contentLength.toString()) : _Function.identity),
    cookies: error.cookies
  };
  const content = error.content;
  if (content._tag === "Empty") {
    return HttpServerResponse.empty(options);
  } else if (content._tag === "Uint8Array") {
    return HttpServerResponse.uint8Array(content.body, options);
  } else if (content._tag === "Raw") {
    return HttpServerResponse.raw(content.body, options);
  } else if (content._tag === "Stream") {
    return HttpServerResponse.stream(content.stream, options);
  } else if (content._tag === "FormData") {
    return HttpServerResponse.formData(content.formData, options);
  }
  return (0, _Function.absurd)(content);
};
/** @internal */
exports.toResponse = toResponse;
const make = (status, body, options) => HttpErrorImpl.unsafeFromUnknown(status, body, options);
exports.make = make;
const makeStatus = status => (body, options) => HttpErrorImpl.unsafeFromUnknown(status, body, options);
/** @internal */
exports.makeStatus = makeStatus;
const isHttpError = error => typeof error === "object" && error !== null && TypeId in error;
exports.isHttpError = isHttpError;
//# sourceMappingURL=http-error.js.map