"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uuidLogAnnotation = exports.errorLog = exports.accessLog = void 0;
var HttpMiddleware = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/HttpMiddleware"));
var HttpServerRequest = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/HttpServerRequest"));
var Effect = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Effect"));
var FiberRef = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/FiberRef"));
var _Function = /*#__PURE__*/require("effect/Function");
var HashMap = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/HashMap"));
var LogLevel = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/LogLevel"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/**
 * Mechanism for extendning behaviour of all handlers on the server.
 *
 * @since 1.0.0
 */

/** @internal */
const accessLog = (level = LogLevel.Info) => HttpMiddleware.make(app => (0, _Function.pipe)(HttpServerRequest.HttpServerRequest, Effect.flatMap(request => Effect.logWithLevel(level, `${request.method} ${request.url}`)), Effect.flatMap(() => app)));
/** @internal */
exports.accessLog = accessLog;
const uuidLogAnnotation = (logAnnotationKey = "requestId") => HttpMiddleware.make(app => (0, _Function.pipe)(Effect.sync(() => crypto.randomUUID()), Effect.flatMap(uuid => FiberRef.update(FiberRef.currentLogAnnotations, HashMap.set(logAnnotationKey, uuid))), Effect.flatMap(() => app)));
/** @internal */
exports.uuidLogAnnotation = uuidLogAnnotation;
const errorLog = exports.errorLog = /*#__PURE__*/HttpMiddleware.make(app => Effect.gen(function* (_) {
  const request = yield* _(HttpServerRequest.HttpServerRequest);
  const response = yield* _(app, Effect.tapErrorCause(Effect.logError));
  if (response.status >= 400 && response.status < 500) {
    yield* _(Effect.logWarning(`${request.method.toUpperCase()} ${request.url} client error ${response.status}`));
  } else if (response.status >= 500) {
    yield* _(Effect.logError(`${request.method.toUpperCase()} ${request.url} server error ${response.status}`));
  }
  return response;
}));
//# sourceMappingURL=middlewares.js.map