"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.make = void 0;
var Effect = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Effect"));
var _Function = /*#__PURE__*/require("effect/Function");
var ApiEndpoint = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiEndpoint.js"));
var ClientRequestEncoder = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./clientRequestEncoder.js"));
var example_compiler = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./example-compiler.js"));
var utils = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./utils.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const make = (api, option) => api.groups.flatMap(group => group.endpoints).reduce((client, endpoint) => {
  const requestEncoder = ClientRequestEncoder.create(endpoint);
  const responseSchema = utils.createResponseSchema(endpoint);
  const customResponses = option?.responses;
  const customResponse = customResponses && customResponses[ApiEndpoint.getId(endpoint)];
  const fn = (args, mapRequest) => {
    return (0, _Function.pipe)(requestEncoder.encodeRequest(args), Effect.map(mapRequest ?? _Function.identity), Effect.flatMap(() => {
      if (customResponse !== undefined) {
        return Effect.succeed(customResponse);
      } else if (responseSchema === undefined) {
        return Effect.void;
      }
      return example_compiler.randomExample(responseSchema);
    }));
  };
  return {
    ...client,
    [ApiEndpoint.getId(endpoint)]: fn
  };
}, {});
exports.make = make;
//# sourceMappingURL=mock-client.js.map