"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.number = exports.int = exports.Number = exports.NonEmptyArray = exports.Int = exports.Array = void 0;
var Schema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Schema"));
var circular = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./circular.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const Number = exports.Number = /*#__PURE__*/Schema.NumberFromString.pipe(/*#__PURE__*/circular.annotate(() => ({
  type: "number",
  description: "a number"
})));
const number = schema => Schema.compose(Schema.NumberFromString, schema, {
  strict: true
}).pipe(circular.annotate(() => ({
  type: "number",
  description: "a number"
})));
/** @internal */
exports.number = number;
const Int = exports.Int = /*#__PURE__*/Schema.compose(Schema.NumberFromString, Schema.Int).pipe(/*#__PURE__*/circular.annotate(() => ({
  type: "integer",
  description: "an integer"
})));
const int = schema => Schema.compose(Int, schema, {
  strict: true
}).pipe(circular.annotate(() => ({
  type: "integer",
  description: "an integer"
})));
/** @internal */
exports.int = int;
const Array = schema => {
  const stringToStringArraySchema = Schema.transform(Schema.String, Schema.Array(Schema.String), {
    decode: i => [i],
    encode: i => i[0]
  });
  const arraySchema = Schema.Array(schema);
  const stringToArraySchema = Schema.compose(stringToStringArraySchema, arraySchema, {
    strict: true
  });
  return Schema.optionalWith(Schema.Union(stringToArraySchema, arraySchema).pipe(circular.annotate(compile => ({
    type: "array",
    items: compile(schema)
  }))), {
    exact: true,
    default: () => []
  });
};
/** @internal */
exports.Array = Array;
const NonEmptyArray = schema => {
  const stringToStringArraySchema = Schema.transform(Schema.String, Schema.NonEmptyArray(Schema.String), {
    decode: i => [i],
    encode: i => i[0]
  });
  const arraySchema = Schema.NonEmptyArray(schema);
  const stringToArraySchema = Schema.compose(stringToStringArraySchema, arraySchema, {
    strict: true
  });
  return Schema.Union(stringToArraySchema, arraySchema).pipe(circular.annotate(compile => ({
    type: "array",
    items: compile(schema)
  })));
};
exports.NonEmptyArray = NonEmptyArray;
//# sourceMappingURL=query-schema.js.map