"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.plainText = exports.make = exports.json = exports.TypeId = void 0;
var Data = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Data"));
var Effect = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Effect"));
var Pipeable = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Pipeable"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const TypeId = exports.TypeId = /*#__PURE__*/Symbol.for("effect-http/Representation/Representation");
/** @internal */
class RepresentationErrorImpl extends /*#__PURE__*/Data.TaggedError("RepresentationError") {}
/** @internal */
const representationProto = {
  [TypeId]: TypeId,
  pipe() {
    return Pipeable.pipeArguments(this, arguments);
  }
};
/** @internal */
const make = fields => {
  const representation = Object.create(representationProto);
  return Object.assign(representation, fields);
};
/** @internal */
exports.make = make;
const json = exports.json = /*#__PURE__*/make({
  stringify: input => Effect.try({
    try: () => JSON.stringify(input),
    catch: error => new RepresentationErrorImpl({
      message: `JSON parsing failed with ${error}`
    })
  }),
  parse: input => Effect.try({
    try: () => JSON.parse(input),
    catch: error => new RepresentationErrorImpl({
      message: `JSON stringify failed with ${error}`
    })
  }),
  contentType: "application/json"
});
/** @internal */
const plainText = exports.plainText = /*#__PURE__*/make({
  stringify: input => {
    if (typeof input === "string") {
      return Effect.succeed(input);
    } else if (typeof input === "number") {
      return Effect.succeed(String(input));
    }
    return json.stringify(input);
  },
  parse: Effect.succeed,
  contentType: "text/plain"
});
//# sourceMappingURL=representation.js.map