"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSchema = exports.createResponseSchema = void 0;
var Schema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Schema"));
var ApiEndpoint = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiEndpoint.js"));
var ApiResponse = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiResponse.js"));
var ApiSchema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../ApiSchema.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const getSchema = (input, defaultSchema = Schema.Unknown) => ApiSchema.isIgnored(input) ? defaultSchema : input;
/** @internal */
exports.getSchema = getSchema;
const createResponseSchema = endpoint => {
  const response = ApiEndpoint.getResponse(endpoint);
  const isFullResponse = ApiEndpoint.isFullResponse(endpoint);
  if (!isFullResponse && ApiSchema.isIgnored(ApiResponse.getBodySchema(response[0]))) {
    return undefined;
  }
  if (!isFullResponse) {
    return getSchema(ApiResponse.getBodySchema(response[0]));
  }
  return Schema.Union(...response.map(response => Schema.Struct({
    status: Schema.Literal(ApiResponse.getStatus(response)),
    body: getSchema(ApiResponse.getBodySchema(response)),
    headers: getSchema(ApiResponse.getHeadersSchema(response), Schema.Record({
      key: Schema.String,
      value: Schema.String
    }))
  })));
};
exports.createResponseSchema = createResponseSchema;
//# sourceMappingURL=utils.js.map