/**
 * @since 1.0.0
 */
import type * as Schema from "effect/Schema";
/**
 * @category type id
 * @since 1.0.0
 */
export declare const IgnoredId: unique symbol;
/**
 * @category models
 * @since 1.0.0
 */
export type IgnoredId = typeof IgnoredId;
/**
 * @category type id
 * @since 1.0.0
 */
export declare const Ignored: Ignored;
/**
 * @category type id
 * @since 1.0.0
 */
export interface Ignored {
    readonly [IgnoredId]: IgnoredId;
}
/**
 * @category refinements
 * @since 1.0.0
 */
export declare const isIgnored: (u: unknown) => u is Ignored;
/**
 * FormData schema
 *
 * @category schemas
 * @since 1.0.0
 */
export declare const FormData: Schema.Schema<FormData>;
//# sourceMappingURL=ApiSchema.d.ts.map