/**
 * Derivation of `OpenApi` schema from an instance of `Api`.
 *
 * @since 1.0.0
 */
import type * as Schema from "effect/Schema";
import type * as Api from "./Api.js";
import type * as OpenApiTypes from "./OpenApiTypes.js";
/**
 * Generate OpenApi specification for the Api.
 *
 * @category constructors
 * @since 1.0.0
 */
export declare const make: (api: Api.Api.Any) => OpenApiTypes.OpenAPISpec;
/**
 * Generate OpenApi specification for the Api.
 *
 * @category constructors
 * @since 1.0.0
 */
export declare const makeSchema: (api: Schema.Schema.AnyNoContext) => OpenApiTypes.OpenAPISchemaType;
/**
 * Set up an OpenAPI for the given schema.
 *
 * @category combining
 * @since 1.0.0
 */
export declare const annotate: (annotation: (compiler: (schema: Schema.Schema.Any) => OpenApiTypes.OpenAPISchemaType) => OpenApiTypes.OpenAPISchemaType) => <S extends Schema.Annotable.All>(self: S) => Schema.Annotable.Self<S>;
//# sourceMappingURL=OpenApi.d.ts.map