/**
 * HTTP query parameters.
 *
 * @since 1.0.0
 */
import type * as Schema from "effect/Schema";
/**
 * @category schema
 * @since 1.0.0
 */
export declare const Number: Schema.Schema<number, string>;
/**
 * @category schema
 * @since 1.0.0
 */
export declare const number: <A, R>(schema: Schema.Schema<A, number, R>) => Schema.Schema<A, string, R>;
/**
 * @category schema
 * @since 1.0.0
 */
export declare const Int: Schema.Schema<number, string>;
/**
 * @category schema
 * @since 1.0.0
 */
export declare const int: <A, R>(schema: Schema.Schema<A, number, R>) => Schema.Schema<A, string, R>;
/**
 * @category schema
 * @since 1.0.0
 */
export declare const Array: <A, R>(schema: Schema.Schema<A, string, R>) => Schema.optionalWith<Schema.Schema<ReadonlyArray<A>, string | ReadonlyArray<string>, R>, {
    exact: true;
    default: () => [];
}>;
/**
 * @category schema
 * @since 1.0.0
 */
export declare const NonEmptyArray: <A, R>(schema: Schema.Schema<A, string, R>) => Schema.Schema<readonly [A, ...Array<A>], string | readonly [string, ...Array<string>], R>;
//# sourceMappingURL=QuerySchema.d.ts.map