import * as ApiSchema from "./ApiSchema.js";
import * as internal from "./internal/api.js";
/**
 * @since 1.0.0
 * @category type id
 */
export const TypeId = internal.TypeId;
/**
 * @category constructors
 * @since 1.0.0
 */
export const make = internal.make;
/**
 * @category combining
 * @since 1.0.0
 */
export const addEndpoint = internal.addEndpoint;
/**
 * @category combining
 * @since 1.0.0
 */
export const addGroup = internal.addGroup;
/**
 * @category getters
 * @since 1.0.0
 */
export const getEndpoint = internal.getEndpoint;
export {
/**
 * @category modifications
 * @since 1.0.0
 */
addResponse,
/**
 * @category constructors
 * @since 1.0.0
 */
delete,
/**
 * @category constructors
 * @since 1.0.0
 */
get,
/**
 * @category constructors
 * @since 1.0.0
 */
make as endpoint,
/**
 * @category constructors
 * @since 1.0.0
 */
patch,
/**
 * @category constructors
 * @since 1.0.0
 */
post,
/**
 * @category constructors
 * @since 1.0.0
 */
put,
/**
 * @category modifications
 * @since 1.0.0
 */
setOptions as setEndpointOptions,
/**
 * @category constructors
 * @since 1.0.0
 */
setRequest,
/**
 * @category modifications
 * @since 1.0.0
 */
setRequestBody,
/**
 * @category modifications
 * @since 1.0.0
 */
setRequestHeaders,
/**
 * @category modifications
 * @since 1.0.0
 */
setRequestPath,
/**
 * @category modifications
 * @since 1.0.0
 */
setRequestQuery,
/**
 * @category modifications
 * @since 1.0.0
 */
setResponse,
/**
 * @category modifications
 * @since 1.0.0
 */
setResponseBody,
/**
 * @category modifications
 * @since 1.0.0
 */
setResponseHeaders,
/**
 * @category modifications
 * @since 1.0.0
 */
setResponseRepresentations,
/**
 * @category modifications
 * @since 1.0.0
 */
setResponseStatus,
/**
 * @category modifications
 * @since 1.0.0
 */
setSecurity } from "./ApiEndpoint.js";
/**
 * @category combining
 * @since 1.0.0
 */
export const setOptions = internal.setOptions;
/**
 * FormData schema
 *
 * @category schemas
 * @since 1.0.0
 */
export const FormData = ApiSchema.FormData;
/**
 * @category refinements
 * @since 1.0.0
 */
export const isApi = internal.isApi;
//# sourceMappingURL=Api.js.map