import * as internal from "./internal/api-endpoint.js";
/**
 * @since 1.0.0
 * @category type id
 */
export const TypeId = internal.TypeId;
/**
 * @category constructors
 * @since 1.0.0
 */
export const make = internal.make;
/**
 * @category constructors
 * @since 1.0.0
 */
export const get = (...args) => make("GET", ...args);
/**
 * @category constructors
 * @since 1.0.0
 */
export const post = (...args) => make("POST", ...args);
/**
 * @category constructors
 * @since 1.0.0
 */
export const put = (...args) => make("PUT", ...args);
/**
 * @category constructors
 * @since 1.0.0
 */
export const patch = (...args) => make("PATCH", ...args);
const _delete = (...args) => make("DELETE", ...args);
export {
/**
 * @category constructors
 * @since 1.0.0
 */
_delete as delete };
/**
 * @category modifications
 * @since 1.0.0
 */
export const setRequest = internal.setRequest;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setRequestBody = internal.setRequestBody;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setRequestPath = internal.setRequestPath;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setRequestQuery = internal.setRequestQuery;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setRequestHeaders = internal.setRequestHeaders;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setSecurity = internal.setSecurity;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setOptions = internal.setOptions;
/**
 * @category modifications
 * @since 1.0.0
 */
export const getId = internal.getId;
/**
 * @category getters
 * @since 1.0.0
 */
export const getRequest = internal.getRequest;
/**
 * @category getters
 * @since 1.0.0
 */
export const getResponse = internal.getResponse;
/**
 * @category getters
 * @since 1.0.0
 */
export const getSecurity = internal.getSecurity;
/**
 * @category getters
 * @since 1.0.0
 */
export const getPath = internal.getPath;
/**
 * @category getters
 * @since 1.0.0
 */
export const getMethod = internal.getMethod;
/**
 * @category getters
 * @since 1.0.0
 */
export const getOptions = internal.getOptions;
/**
 * @category getters
 * @since 1.0.0
 */
export const setResponse = internal.setResponse;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setResponseStatus = internal.setResponseStatus;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setResponseBody = internal.setResponseBody;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setResponseHeaders = internal.setResponseHeaders;
/**
 * @category modifications
 * @since 1.0.0
 */
export const addResponse = internal.addResponse;
/**
 * @category modifications
 * @since 1.0.0
 */
export const setResponseRepresentations = internal.setResponseRepresentations;
/**
 * Is used by the client and server implementation to determine whether
 * to use a full `{ status; body; headers }` response or just the body.
 *
 * The logic is that if there is only one declared response and it doesn't
 * specify any headers, the simplified version with body only is used, otherwise
 * the full response is used.
 *
 * @category getters
 * @since 1.0.0
 */
export const isFullResponse = internal.isFullResponse;
/**
 * @category refinements
 * @since 1.0.0
 */
export const isApiEndpoint = internal.isApiEndpoint;
//# sourceMappingURL=ApiEndpoint.js.map