/**
 * Derivation of `OpenApi` schema from an instance of `Api`.
 *
 * @since 1.0.0
 */
import * as internal from "./internal/open-api.js";
/**
 * Generate OpenApi specification for the Api.
 *
 * @category constructors
 * @since 1.0.0
 */
export const make = internal.make;
/**
 * Generate OpenApi specification for the Api.
 *
 * @category constructors
 * @since 1.0.0
 */
export const makeSchema = internal.makeSchema;
/**
 * Set up an OpenAPI for the given schema.
 *
 * @category combining
 * @since 1.0.0
 */
export const annotate = internal.annotate;
//# sourceMappingURL=OpenApi.js.map