import * as internal from "./internal/router-builder.js";
/**
 * @since 1.0.0
 * @category type id
 */
export const TypeId = internal.TypeId;
/**
 * Create a new unimplemeted `RouterBuilder` from an `Api`.
 *
 * @category handling
 * @since 1.0.0
 */
export const make = internal.make;
/**
 * Handle an endpoint using a raw `Router.Route.Handler`.
 *
 * @category handling
 * @since 1.0.0
 */
export const handleRaw = internal.handleRaw;
/**
 * Handle an endpoint using a handler function.
 *
 * @category constructors
 * @since 1.0.0
 */
export const handle = internal.handle;
/**
 * Handle an endpoint using a handler function.
 *
 * @category constructors
 * @since 1.0.0
 */
export const handler = internal.handler;
/**
 * Modify the `Router`.
 *
 * @category mapping
 * @since 1.0.0
 */
export const mapRouter = internal.mapRouter;
/**
 * Handle an endpoint using a raw `Router.Route.Handler`.
 *
 * @category destructors
 * @since 1.0.0
 */
export const getRouter = internal.getRouter;
/**
 * Create an `App` instance.
 *
 * @category destructors
 * @since 1.0.0
 */
export const build = internal.build;
/**
 * Create an `App` instance.
 *
 * Warning: this function doesn't enforce all the endpoints are implemented and
 * a running server might not conform the given Api spec.
 *
 * @category destructors
 * @since 1.0.0
 */
export const buildPartial = internal.buildPartial;
/**
 * @category combining
 * @since 1.0.0
 */
export const merge = internal.merge;
/**
 * @category refinements
 * @since 1.0.0
 */
export const isRouterBuilder = internal.isRouterBuilder;
//# sourceMappingURL=RouterBuilder.js.map