import * as internal from "./internal/security.js";
/**
 * @since 1.0.0
 * @category type id
 */
export const TypeId = internal.TypeId;
/**
 * @category constructors
 * @since 1.0.0
 */
export const make = internal.make;
/**
 * @category getters
 * @since 1.0.0
 */
export const handleRequest = internal.handleRequest;
/**
 * @category getters
 * @since 1.0.0
 */
export const getOpenApi = internal.getOpenApi;
/**
 * @category combinators
 * @since 1.0.0
 */
export const mapHandler = internal.mapHandler;
/**
 * @category combinators
 * @since 1.0.0
 */
export const and = internal.and;
/**
 * @category combinators
 * @since 1.0.0
 */
export const or = internal.or;
/**
 * @category combinators
 * @since 1.0.0
 */
export const map = internal.map;
/**
 * @category combinators
 * @since 1.0.0
 */
export const as = internal.as;
/**
 * @category combinators
 * @since 1.0.0
 */
export const asSome = internal.asSome;
/**
 * @category combinators
 * @since 1.0.0
 */
export const mapEffect = internal.mapEffect;
/**
 * @category combinators
 * @since 1.0.0
 */
export const mapSchema = internal.mapSchema;
/**
 * Creates bearer http security
 *
 * @category constructors
 * @since 1.0.0
 */
export const bearer = internal.bearer;
/**
 * Creates basic http security
 *
 * @category constructors
 * @since 1.0.0
 */
export const basic = internal.basic;
/**
 * Creates always allowing security without a security scheme
 *
 * @category constructors
 * @since 1.0.0
 */
export const unit = internal.unit;
/**
 * Creates always failing security without a security scheme
 *
 * @category constructors
 * @since 1.0.0
 */
export const never = internal.never;
/**
 * Creates basic http security
 *
 * @category constructors
 * @since 1.0.0
 */
export const apiKey = internal.apiKey;
//# sourceMappingURL=Security.js.map