import * as Pipeable from "effect/Pipeable";
import * as ApiEndpoint from "../ApiEndpoint.js";
import * as api_endpoint from "./api-endpoint.js";
/** @internal */
export const TypeId = /*#__PURE__*/Symbol.for("effect-http/Api/ApiGroupTypeId");
/** @internal */
export const variance = {
  /* c8 ignore next */
  _A: _ => _
};
/** @internal */
export class ApiGroupImpl {
  name;
  endpoints;
  options;
  [TypeId] = variance;
  constructor(name, endpoints, options) {
    this.name = name;
    this.endpoints = endpoints;
    this.options = options;
  }
  pipe() {
    return Pipeable.pipeArguments(this, arguments);
  }
}
/** @internal */
export const isApiGroup = u => typeof u === "object" && u !== null && TypeId in u;
/** @internal */
export const make = (name, options) => new ApiGroupImpl(name, [], {
  ...options
});
/** @internal */
export const validateNewEndpoint = (self, endpoint) => {
  if (self.endpoints.some(e => ApiEndpoint.getId(e) === ApiEndpoint.getId(endpoint))) {
    throw new Error(`Endpoint with id ${ApiEndpoint.getId(endpoint)} already exists`);
  }
};
/** @internal */
export const addEndpoint = endpoint => self => {
  api_endpoint.validateEndpoint(endpoint);
  validateNewEndpoint(self, endpoint);
  return new ApiGroupImpl(self.name, [...self.endpoints, endpoint], self.options);
};
/** @internal */
export const setOptions = options => self => new ApiGroupImpl(self.name, self.endpoints, {
  ...self.options,
  ...options
});
//# sourceMappingURL=api-group.js.map