import * as Pipeable from "effect/Pipeable";
import * as ApiSchema from "../ApiSchema.js";
/** @internal */
export const TypeId = /*#__PURE__*/Symbol.for("effect-http/Api/RequestTypeId");
/** @internal */
export const variance = {
  /* c8 ignore next */
  _B: _ => _,
  /* c8 ignore next */
  _P: _ => _,
  /* c8 ignore next */
  _Q: _ => _,
  /* c8 ignore next */
  _H: _ => _,
  /* c8 ignore next */
  _R: _ => _
};
/** @internal */
export class ApiRequestImpl {
  body;
  path;
  query;
  headers;
  [TypeId] = variance;
  constructor(body, path, query, headers) {
    this.body = body;
    this.path = path;
    this.query = query;
    this.headers = headers;
  }
  pipe() {
    return Pipeable.pipeArguments(this, arguments);
  }
}
/** @internal */
export const defaultRequest = /*#__PURE__*/new ApiRequestImpl(ApiSchema.Ignored, ApiSchema.Ignored, ApiSchema.Ignored, ApiSchema.Ignored);
/** @internal */
export const getBodySchema = request => request.body;
/** @internal */
export const getPathSchema = request => request.path;
/** @internal */
export const getQuerySchema = request => request.query;
/** @internal */
export const getHeadersSchema = request => request.headers;
/** @internal */
export const setBody = schema => request => new ApiRequestImpl(schema, getPathSchema(request), getQuerySchema(request), getHeadersSchema(request));
/** @internal */
export const setPath = schema => request => new ApiRequestImpl(getBodySchema(request), schema, getQuerySchema(request), getHeadersSchema(request));
/** @internal */
export const setQuery = schema => request => new ApiRequestImpl(getBodySchema(request), getPathSchema(request), schema, getHeadersSchema(request));
/** @internal */
export const setHeaders = schema => request => new ApiRequestImpl(getBodySchema(request), getPathSchema(request), getQuerySchema(request), schema // TODO: transform schema properties to lowercase
);
//# sourceMappingURL=api-request.js.map