import * as Predicate from "effect/Predicate";
import * as Schema from "effect/Schema";
import * as circular from "./circular.js";
/** @internal */
export const IgnoredId = /*#__PURE__*/Symbol.for("effect-http/ignored-id");
/** @internal */
export const Ignored = {
  [IgnoredId]: IgnoredId
};
/** @internal */
export const formDataSchema = /*#__PURE__*/Schema.instanceOf(FormData).pipe(/*#__PURE__*/circular.annotate(() => ({
  type: "string",
  format: "binary",
  description: "Multipart form data"
})));
/** @internal */
export const isIgnored = u => Predicate.hasProperty(u, IgnoredId) && u[IgnoredId] === IgnoredId;
//# sourceMappingURL=api-schema.js.map