import * as Schema from "effect/Schema";
import * as circular from "./circular.js";
/** @internal */
export const Number = /*#__PURE__*/Schema.NumberFromString.pipe(/*#__PURE__*/circular.annotate(() => ({
  type: "number",
  description: "a number"
})));
export const number = schema => Schema.compose(Schema.NumberFromString, schema, {
  strict: true
}).pipe(circular.annotate(() => ({
  type: "number",
  description: "a number"
})));
/** @internal */
export const Int = /*#__PURE__*/Schema.compose(Schema.NumberFromString, Schema.Int).pipe(/*#__PURE__*/circular.annotate(() => ({
  type: "integer",
  description: "an integer"
})));
export const int = schema => Schema.compose(Int, schema, {
  strict: true
}).pipe(circular.annotate(() => ({
  type: "integer",
  description: "an integer"
})));
/** @internal */
export const Array = schema => {
  const stringToStringArraySchema = Schema.transform(Schema.String, Schema.Array(Schema.String), {
    decode: i => [i],
    encode: i => i[0]
  });
  const arraySchema = Schema.Array(schema);
  const stringToArraySchema = Schema.compose(stringToStringArraySchema, arraySchema, {
    strict: true
  });
  return Schema.optionalWith(Schema.Union(stringToArraySchema, arraySchema).pipe(circular.annotate(compile => ({
    type: "array",
    items: compile(schema)
  }))), {
    exact: true,
    default: () => []
  });
};
/** @internal */
export const NonEmptyArray = schema => {
  const stringToStringArraySchema = Schema.transform(Schema.String, Schema.NonEmptyArray(Schema.String), {
    decode: i => [i],
    encode: i => i[0]
  });
  const arraySchema = Schema.NonEmptyArray(schema);
  const stringToArraySchema = Schema.compose(stringToStringArraySchema, arraySchema, {
    strict: true
  });
  return Schema.Union(stringToArraySchema, arraySchema).pipe(circular.annotate(compile => ({
    type: "array",
    items: compile(schema)
  })));
};
//# sourceMappingURL=query-schema.js.map